package nxt.http;

import nxt.Nxt;
import org.json.simple.JSONObject;
import org.json.simple.JSONStreamAware;

import javax.servlet.http.HttpServletRequest;

public final class ClearUnconfirmedTransactions extends APIServlet.APIRequestHandler {

    static final ClearUnconfirmedTransactions instance = new ClearUnconfirmedTransactions();

    private ClearUnconfirmedTransactions() {
        super(new APITag[] {APITag.DEBUG});
    }

    @Override
    JSONStreamAware processRequest(HttpServletRequest req) {
        JSONObject response = new JSONObject();
        try {
            Nxt.getTransactionProcessor().clearUnconfirmedTransactions();
            response.put("done", true);
        } catch (RuntimeException e) {
            response.put("error", e.toString());
        }
        return response;
    }

    @Override
    final boolean requirePost() {
        return true;
    }

}
